/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.benchmark.jcr;

import javax.jcr.SimpleCredentials;

import org.exoplatform.container.StandaloneContainer;
import org.exoplatform.services.jcr.RepositoryService;

import com.sun.japex.TestCase;

/**
 * Created by The eXo Platform SARL Author : Vitaliy Obmanjuk
 * vitaliy.obmanjuk@exoplatform.com.ua 07.03.2007
 */
public class ExoJCRDriver extends JCRDriverMethods {

  private StandaloneContainer container;

  private RepositoryService   repositoryService;

  public void initializeDriver() {
    super.initializeDriver();
    try {
      String path = Thread.currentThread().getContextClassLoader().getResource(
          "conf/standalone/test-configuration-benchmark.xml").toString();
      StandaloneContainer.setConfigurationURL(path);
      container = StandaloneContainer.getInstance();
      System.out.println("=== container instance: " + (container));
      if (System.getProperty("java.security.auth.login.config") == null)
        System.setProperty("java.security.auth.login.config", Thread.currentThread()
            .getContextClassLoader().getResource("login.conf").toString());
      repositoryService = (RepositoryService) container
          .getComponentInstanceOfType(RepositoryService.class);
      repository = repositoryService.getRepository();
      //login for the first time to get session access 
      repository.login(new SimpleCredentials("admin", "admin".toCharArray()), "ws");      
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  public void prepare(TestCase testCase) {
    // Here we may set some tc parameters
  }

  public void warmup(TestCase tc) {
    // do nothing
  }
  
  public void run(final TestCase tc) {
    super.run(tc);
  }
  
  public void finish(TestCase testCase) {
    // report generation or smth else
  }
  
}
